
function readfile_getme(getcomponent,getinterface,debug) {
    var component=Components.classes[getcomponent].getService();
    if (debug) alert(component);
    var inter=component.QueryInterface(Components.interfaces[getinterface]);
    if (debug) alert(inter);
    return inter;
}
function readfile_getmeNew(getcomponent,getinterface,debug) {
    if (debug) alert(getcomponent+"::"+getinterface);
    var component=new Components.Constructor(getcomponent,getinterface);
    return new component();
}

/*
 * If opening a zipfile, you can optionally pass zipContent as the 
 * internal file to open. Otherwise it's assumed to have the same name
 * as the zipfile, minus the extension.
 */
EUCFileReader.prototype.open = function(zipContent) {
    this.fileInst=readfile_getmeNew(
            "@mozilla.org/file/local;1", "nsILocalFile");
    this.fileInst.initWithPath(this.path);
    this.eucConverter=readfile_getmeNew(
            "@mozilla.org/intl/scriptableunicodeconverter","nsIScriptableUnicodeConverter");
    this.eucConverter.charset="euc-jp";
    this.inputStream = readfile_getmeNew(
            "@mozilla.org/scriptableinputstream;1",
            "nsIScriptableInputStream");
    if (this.path.indexOf(".zip")!=-1) {
        this.zipReader=readfile_getmeNew(
                "@mozilla.org/libjar/zip-reader;1","nsIZipReader");
        this.zipReader.init(this.fileInst);
        this.zipReader.open();
        var strippedName=this.fileInst.leafName.replace(/\.zip$/,"");
        if (zipContent) strippedName=zipContent;
        this.zipReaderStream=this.zipReader.getInputStream(strippedName);
        this.inputStream.init(this.zipReaderStream);
    } else {
        var ioService = 
            readfile_getmeNew("@mozilla.org/network/io-service;1","nsIIOService");
        var uri=ioService.newURI("file://"+this.path,null,null);
        
        this.fileChannel =
            ioService.newChannelFromURI(uri);
        this.fileChannelStream=this.fileChannel.open();

        this.inputStream.init(this.fileChannelStream);
    }
    this.buffer=new Array();
}

/*
 * Don't use externally -- this doesn't include the buffer 
 */
EUCFileReader.prototype._eof = function() {
    return(this.inputStream.available() <= 0);
}

EUCFileReader.prototype._latin2euc = function(txt) {
    if (txt!=null) {
        return this.eucConverter.ConvertToUnicode(txt);
    } else {
        return null;
    }
}

EUCFileReader.prototype.seek = function(from, what) { // from = 0=BEG,1=CUR,2=END
    this.inputStream.seek(from,what);
}

EUCFileReader.prototype.readAll = function() {
    return this._latin2euc(this.inputStream.read(99999999));
}

EUCFileReader.prototype.slurp = function() {
    return this.readAll().split(/\r?\n/);
}

EUCFileReader.prototype.readLine = function() {
    if (this.buffer==null) return null;
    if (this.buffer.length>1) { // so [0] must be a full line
        var tmp=this.buffer.shift();
        return this._latin2euc(tmp);
    } else {
        var tmpString;
        if (this.buffer.length==1) {
            tmpString=this.buffer.shift();
        } else {
            tmpString="";
        }
        var i=-1;
        while ((!this._eof())&&(i==-1)) {
            tmpString=tmpString+this.inputStream.read(this.bufferSize);
            i=tmpString.indexOf("\n");
        }
        if (i>=0) {
            var tarray=tmpString.split("\n");
            for (var ti=1;ti<tarray.length;ti++) {
                this.buffer.push(tarray[ti]);
            }
            var tmp=tarray[0];
            return this._latin2euc(tmp);
        } else {
            this.buffer=null;
            return this._latin2euc(tmpString);
        }
    }
}
var _checkOrFetchResult=new Object();
function checkOrFetchProgress(path) {
    if (path.indexOf("chrome:")==0) {
        path=chromeToFilePath(path);
    }
    var i=_checkOrFetchResult["progress:"+path];
    if (i) {
        return Math.floor(_checkOrFetchResult["progress:"+path]*100)/100;
    } else {
        return 0;
    }
}
function checkOrFetchFinished(path) {
    if (path.indexOf("chrome:")==0) {
        path=chromeToFilePath(path);
    }
    if (_checkOrFetchResult[path]) {
        return true;
    }
    return false;
}
function checkOrFetch(path,fetchurl) {
    if (path.indexOf("chrome:")==0) {
        path=chromeToFilePath(path);
    }
    var fileInst=readfile_getmeNew(
            "@mozilla.org/file/local;1", "nsILocalFile");
    fileInst.initWithPath(path);
    if (!fileInst.exists()) {
        var downloadQ=
            confirm("A file necessary for proper functioning could not be found: \n" +
                    "  \""+path+"\"\n"+
                    "If this is your first time running, it may need to be "+
                    "downloaded.\n"+
                    "Please confirm that your network is connected before proceeding.\n"+
                    "\n"+
                    "Start automatic download from "+
                    fetchurl+"?");
        if (downloadQ==false) {
            return false;
        } else {
            var ioService = 
                readfile_getmeNew("@mozilla.org/network/io-service;1","nsIIOService");
            var uri=ioService.newURI(fetchurl,null,null);
            var persist =
                readfile_getmeNew("@mozilla.org/embedding/browser/nsWebBrowserPersist;1",
                        "nsIWebBrowserPersist");
            var n = Components.interfaces.nsIWebBrowserPersist;
            const flags = n.PERSIST_FLAGS_NO_CONVERSION |
                n.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
            persist.persistFlags = flags | n.PERSIST_FLAGS_BYPASS_CACHE;
            var persistListener = new Object();
            persistListener.QueryInterface = function(aIID) {
                if(aIID.equals(Components.interfaces.nsIWebProgressListener))
                    return this;
                throw Components.results.NS_NOINTERFACE;
            }
            persistListener.init = function() { }
            persistListener.destroy = function() { }
            persistListener.onProgressChange=function(aWebProgress, aRequest,
                    aCurSelfProgress, aMaxSelfProgress,
                    aCurTotalProgress, aMaxTotalProgress) { 
                _checkOrFetchResult["progress:"+this.path]=aCurTotalProgress/(aMaxTotalProgress+0.001);
            }
            persistListener.onStateChange=function(aWebProgress, aRequest,
                    aStateFlags, aStatus) { 
                if(persist.currentState == persist.PERSIST_STATE_FINISHED) {
                    _checkOrFetchResult[this.path]=true;
                }
            }
            persistListener.onLocationChange=function() { }
            persistListener.onStatusChange=function() { }
            persistListener.onSecurityChange=function() { }
            persistListener.path=path;
            persist.progressListener = persistListener;

            persist.saveURI(uri, null, null, null, null, fileInst);
        }
    } else {
        _checkOrFetchResult[path]=true;
    }
    return true;
}

function chromeToFilePath(path) {
    // add on path to our chrome
    var uri = readfile_getmeNew(
            "@mozilla.org/network/simple-uri;1","nsIURI");
    var chrome_reg=readfile_getme("@mozilla.org/chrome/chrome-registry;1",
            "nsIChromeRegistry");
    uri.spec = path;
    uri.spec = chrome_reg.convertChromeURL(uri);
    path=uri.path;
    var dir =
        readfile_getme("@mozilla.org/file/directory_service;1","nsIProperties");
    var realPath =
        dir.get("AChrom",Components.interfaces.nsIFile).path;
    path=path.replace(/\/chrome\//,"");
    var pathcomps=path.split(/\//);
    var localfile=readfile_getmeNew(
            "@mozilla.org/file/local;1", "nsILocalFile");
    localfile.initWithPath(realPath);
    while (pathcomps.length>0) {
        var relpath=pathcomps.shift();
        localfile.appendRelativePath(relpath);
        path=localfile.path;
    }
    return path;
}

function EUCFileReader(path) {
    if (path.indexOf("chrome:")==0) {
        path=chromeToFilePath(path);
    }
    this.path=path;
    this.bufferSize=2048;
    return this;
}

// really belongs somewhere else, but after all it is a file
var readfile_prefs;
function setPrefFile() {
    readfile_prefs=readfile_getmeNew("@mozilla.org/preferences;1",
            "nsIPref");
}
setPrefFile("chrome://rikaixul/content/prefs.txt");
function setPref(s,value) {
    s="rikaixul."+s;
    readfile_prefs.SetCharPref(s,value);
}
function getPref(s,def) {
    s="rikaixul."+s;
    var ret=readfile_prefs.GetCharPref(s);
    if (!ret) return def; else return ret;
}

