  var _status=null;
  var _status_updatelabel="";
  function setStatus(txt) {
      if (RikaiLoaded) {
          _status.label=txt;
      }
      _status_updatelabel=txt;
  }

  var edictData;
  var kanjidicData;
  var radicalData;
  var radkfileData;
  var tasks=new Array();
  var RikaiLoaded=false;
  var radicalReading=new Object();
  var radicalMeaning=new Object();
  var vconjData=new Array();
  var vconjDescription=new Object();

  function initRikai() {
      //return;
      _status=window.document.getElementById("status");
      tasks.push("checkOrFetch('chrome://rikaixul/content/edict.zip',"+
                 "'http://ftp.cc.monash.edu.au/pub/nihongo/edict.zip')");
      tasks.push("checkOrFetch('chrome://rikaixul/content/kanjidic.zip',"+
              "'http://ftp.cc.monash.edu.au/pub/nihongo/kanjidic.zip')");
      tasks.push("loadRadicalData()");
      tasks.push("loadKanjidicData()");
      tasks.push("loadEdictData()");
      tasks.push("loadRadkfileData()");
      tasks.push("loadVConj()");
      runTasks();
  }
  var startTime=new Date().getTime()/1000;
  function runTasks() {
      _status.label=_status_updatelabel+" "+new Date();
      if (tasks.length>0) {
          eval(tasks.shift());
          setTimeout("runTasks()",10);
      } else {
          RikaiLoaded=true;
          var t2=new Date().getTime()/1000;
          setStatus("ready. Time taken: " + Math.round((t2-startTime)*100)/100 + 
                  (edictData?(", edict entries=" + edictData.length):"")+", kanjidic entries="+
                  kanjidicData.length);
      }
  }
  function loadVConj() {
      var f=new EUCFileReader("chrome://rikaixul/content/vconj");
      f.open();
      var tmpA=f.slurp();
      var i;
      for (i=0;i<tmpA.length;i++) {
          var line=tmpA[i];
          if (line.match(/^#/)) {
              continue;
          } else if (line.charAt(0)=='$') {
              break;
          } else {
              var fields=line.split("\t");
              vconjDescription[fields[0]]=fields[1];
          }
      }
      // conjugations from here
      for (i++;i<tmpA.length;i++) {
          var line=tmpA[i];
          if (line.match(/^#/)) {
              continue;
          } else {
              var fields=line.split("\t");
              var def=new Object();
              def.before=fields[0];
              def.after=fields[1];
              def.reason=fields[2];
              vconjData.push(def);
          }
      }
  }
  function loadRadicalData() {
      var f=new EUCFileReader("chrome://rikaixul/content/radicals.tm");
      f.open();
      var tmpA=f.slurp();
      radicalData=new Object();
      for (var i=0;i<tmpA.length;i++) {
          var line=tmpA[i];
          var rad=line.replace(/^([^ ]*) ([^ ]*).*/,"$1\n$2").split(/\n/);
          if (rad[0].charCodeAt(0)>255) {
              if ((rad[1].charAt(0)=='[')||(rad[1].charAt(0)=='(')) {
                  var val=rad[1];
                  val=val.replace(/^.(.*).$/,"$1");
                  radicalData[rad[0]]=val; // use rad->num
              } else {
                  radicalData[rad[0]]=rad[1];
                  radicalData[rad[1]]=rad[0]; // do num->rad at the same time
              }
          }
      }
      var f2=new EUCFileReader("chrome://rikaixul/content/radical_meanings");
      f2.open();
      var radicalMeanings=f2.slurp();
      for (var i=0;i<radicalMeanings.length;i++) {
          line=radicalMeanings[i].split(" ");
          radicalData[line[0]]=(i+1)+"";
          radicalData[i+1]=line[0];
          radicalReading[i+1]=line[1];
          radicalMeaning[i+1]=line[2];
          radicalReading[line[0]]=line[1];
          radicalMeaning[line[0]]=line[2];
      }
      // fix up radicals that aren't represented in proper form
      for (var rad in radicalData) {
          if (!rad.match(/^[0-9]*$/)) {
              if (radicalData[rad].match(/^[0-9]*$/)) {
                  if (!radicalData[radicalData[rad]]) {
                      radicalData[radicalData[rad]]=rad;
                  }
              }
          }
      }
  }
  function loadRadkfileData() {
      /*if (!checkOrFetchFinished("chrome://rikaixul/content/radkfile.gz")) {
          stat=checkOrFetchProgress("chrome://rikaixul/content/radkfile.gz");
          setStatus("waiting for radkfile.  ("+Math.floor(stat*100)+"% "+
                  new Date()+")");
          tasks.push("loadRadkfileData()");
          return;
      }*/
      var f=new EUCFileReader("chrome://rikaixul/content/radkfile");
      f.open();
      var tmpA=f.slurp();
      radkfileData=new Object();
      var radical="";
      for (var i=0;i<tmpA.length;i++) {
          var line=tmpA[i];
          if (line.match(/^#/)) {
              continue;
          } else if (line.match(/^\$/)) {
              lineA=line.split(/ /);
              radical=lineA[1];
              if (radicalData[radical]) {
                  if (radicalData[radicalData[radical]])
                      radical=radicalData[radicalData[radical]];
              }
          } else {
              for (var j=0;j<line.length;j++) {
                  if (line.charCodeAt(j)>255) {
                      var c=line.charAt(j);
                      if (!radkfileData[c]) {
                          radkfileData[c]=new Object();
                      }
                      radkfileData[c][radical]=true;
                  }
              }
          }
      }
  }
  function addReverseYomi(edict) {
      var l=edict.length;
      for (var i=0;i<l;i++) {
          //if (edict[i].indexOf("(uk)")!=-1) {
              var beg=edict[i].indexOf("[");
              if (beg==-1) {
                  continue;
              } else {
                  var newEntry=edict[i].replace(
                          /^([^ ]*) \[([^ ]*)\](.*)/,
                          "$2 [$1]$3");
                  edict.push(newEntry);
              }
          //}
      }
      return edict;
  }
  function loadEdictData() {
      if (!checkOrFetchFinished("chrome://rikaixul/content/edict.zip")) {
          stat=checkOrFetchProgress("chrome://rikaixul/content/edict.zip");
          setStatus("waiting for edict. ("+Math.floor(stat*100)+"% "+
                  new Date()+")");
          tasks.push("loadEdictData()");
          return;
      }
      var f=new EUCFileReader("chrome://rikaixul/content/edict.zip");
      f.open();
      edictData=addReverseYomi(f.slurp()).sort();
  }
  function loadKanjidicData() {
      if (!checkOrFetchFinished("chrome://rikaixul/content/kanjidic.zip")) {
          stat=checkOrFetchProgress("chrome://rikaixul/content/kanjidic.zip");
          setStatus("waiting for kanjidic. ("+Math.floor(stat*100)+"% "+
                  new Date()+")");
          tasks.push("loadKanjidicData()");
          return;
      }
      var f=new EUCFileReader("chrome://rikaixul/content/kanjidic.zip");
      f.open();
      var data=new Array();
      kanjidicData=f.slurp().sort();
  }

  function binSearch(data, txt, start, end) {
     if (start>=end) return start; 
     var mid=Math.floor((start+end)/2);
     var midS=data[mid].split(/ /)[0];
     if (txt>midS) {
         return binSearch(data,txt,mid+1,end);
     } else if (txt<midS) {
         return binSearch(data,txt,start,mid-1);
     }
     while ((mid>0)&&(txt==data[mid-1].split(/ /)[0])) {
         mid--;
     }
     return mid;
  }
 
  var lastShown=null;
  function showPopup(html,src) {
      if (html=="") return;
      if (lastShown) {
          hidePopup(lastShown);
          lastShown=null;
      }
      lastShown=src;
      src.style.backgroundColor='#FFCCAA';
      var doc=window.frames[0].document;
      var trx;
      if (doc) trx=doc.getElementById("TRX");
      if (trx) {
          var x=0;var y=0;
          while ((src!=null)&&(src !=
                      window.document)) {
              x=x+src.offsetLeft;
              y=y+src.offsetTop;
              src=src.offsetParent;
          }
          var ay=y+35;
          var ax=(x>5)?x:0;
          trx.style.left=50;
          trx.style.width=null;
          trx.innerHTML="<div style='border:1px solid #888888;"+
             " background-color: #eeeebb;"+
             " font-size:16px;'>"+html+"</div>";
          trx.style.width=trx.width+5;
          if (ax+trx.offsetWidth>
                  doc.body.offsetWidth+doc.body.scrollLeft-20) {
              ax=doc.body.offsetWidth+doc.body.scrollLeft-20-
                  trx.offsetWidth
          }
          if (ay+trx.offsetHeight>
                  doc.body.offsetHeight+doc.body.scrollTop-20) {
              ay=y-10-trx.offsetHeight;
              if (ay<doc.body.scrollTop) {
                  ay=y+20;
              }
          }
          trx.style.left=ax;
          trx.style.top=ay;
          trx.style.visibility="visible";
      }
  }

  function hidePopup(src) {
      if (topopuptimeout) eval("clearTimeout(topopuptimeout);");
      if (towritetimeout) eval("clearTimeout(towritetimeout);");
      src.style.backgroundColor='#FFFFFF';
      if (window.frames[0].document.getElementById("TRX")) {
          window.frames[0].document.getElementById("TRX").style.visibility="hidden";
      }
      if (lastShown==src) lastShown=null;
  }
  function setWrite() {
      if (!RikaiLoaded) {
          setStatus("Text Entry awaiting edict ("+new Date()+")");
          return;
      }
      var doc = window.frames[0].document;
      var textinput = window.document.getElementById("textinput").value;
      doc.open("text/html");
      doc.write("<html><body style='cursor:pointer;'><div id=TRX "
              +"style='position:absolute;visibility:hidden;'>&nbsp;</div>"+
              markup(encode_html(textinput+"\n"))+"</body></html>");
      doc.close();
      doc.show=show;
      doc.hide=hidePopup;
      var kanjicard = window.frames[1].document;
      kanjicard.open("text/html");
      kanjicard.write("<html><body><div id='kanjicard'/>"+
              "</body></html>");
      kanjicard.close( );

      var t="";
      var tabbox=window.document.getElementById("maintabbox");
      for (var prop in tabbox) {
          t=t+prop+" ; ";
      }
      //alert(t);
      tabbox.selectedIndex=1;
  }
  var dictionaryXML;
  function replaceAll(txt, pat, rep) {
      var st = txt;
      if (pat.length == 0)
          return st;
      var i = st.indexOf(pat);
      while (i>=0) { 
          st = st.substring(0,i) + rep +
              st.substring(i+pat.length);
          i = st.indexOf(pat,i+rep.length);
      }
      return st;
  }

  function encode_html(txt) {
     txt=replaceAll(txt,"&","&amp;"); 
     txt=replaceAll(txt,"<","&lt;"); 
     txt=replaceAll(txt,">","&gt;"); 
     txt=replaceAll(txt," ","&nbsp;"); 
     txt=replaceAll(txt,"\n","<br>"); 
     return txt;
  }
  function escape_for_js(txt) {
      txt=replaceAll(txt,"'","\\'");
      txt=replaceAll(txt,"\n","\\n");
      return txt;
  }
  var towritekanji="";
  var towritetimeout=null;
  var topopuptxt="";
  var topopupobj=null;
  var topopuptimeout=null;
  var showmetry=0;
  function show(txt,o) {
      if ((txt!=topopuptxt)||(o!=topopupobj)) showmetry++;
      topopuptxt=txt;
      topopupobj=o;
      if (topopuptimeout) eval("clearTimeout(topopuptimeout);");
      topopuptimeout=setTimeout("if (showmetry=="+showmetry+") "+
                  "showPopup(escape_for_js(kanjiLookup(topopuptxt)),topopupobj);",
                  10);

      towritekanji=txt.substring(0,1);
      if (towritetimeout) eval("clearTimeout(towritetimeout);");
      towritetimeout=
          setTimeout("if (showmetry=="+showmetry+") "+
                  "window.frames[1].document.getElementById(\"kanjicard\")."+
                  "innerHTML=kanjiInfo(towritekanji);",11);
  }
  function markup(txt) {
      var out="";
      var i=0;
      for (i=0;i<txt.length;i++) {
          if (txt.charCodeAt(i)>127) {
              out=out+"<span onMouseOver='show(\""+
                  txt.substring(i,i+6)+"\",this);' "+
                  " onMouseOut='hide(this);'>"+
                  txt.charAt(i)+"</span>";
          } else {
              out=out+txt.charAt(i);
          }
      }
      return out;
  }
  function kanjiInfo(txt) {
      var i=binSearch(kanjidicData,txt,0,kanjidicData.length-1);
      var key=kanjidicData[i].split(/ /)[0];
      if (key!=txt) {
          return "";
      } else {
          var rads="";
          if (radkfileData[key]) {
              for (var prop in radkfileData[key]) {
                  if (prop!=key) {
                      rads+="<span style='color:#3333FF'>"+
                          prop+"</span>";
                      if ((radicalReading[prop])&&(radicalMeaning[prop])) {
                          rads+=" </td><td style='font-size:12px;color:#CC3333;"+
                              //"letter-spacing:-0.3em;"+
                              "'>"+
                              radicalReading[prop]+
                              "</td><td style='font-size:9px;color:#CC3333'>"+
                              radicalMeaning[prop];
                      } else {
                          var j=binSearch(kanjidicData,prop,0,kanjidicData.length-1);
                          var radkey=kanjidicData[j].split(/ /)[0];
                          if (radkey==prop) {
                              var defs=kanjidicData[j].split(/[{}]/);
                              if (defs.length>=2) {
                                  rads+=" </td><td colspan=2 style='font-size:9px;color:#CC3333'>"+
                                      defs[1];
                              }
                          }
                      }
                      rads+="</tr><tr>";
                  }
              }
              if (rads!="") 
                  rads="<table style='border:1px dashed "+
                      "black;font-size:12px;padding:4px;text-align:left;'><tr><td>"+
                      rads+"</td></tr></table>";
          }
          var line=kanjidicData[i];
          var mainReadings="";
          var beg;
          for (beg=1;(beg<line.length)&&
                  (line.charCodeAt(beg)<256);beg++) { ; }
          var end;
          for (end=beg+1;(end<line.length)&&(line.charAt(end)!="{");end++) { ; }
          mainReadings=line.substring(beg,end);
          while (mainReadings.match(/\./)) 
              mainReadings=mainReadings.replace(/\.([^ ]*)/,
                  "<span style='color:888888'>$1</span>");
          mainReadings=mainReadings.replace(/T1/,"<br><span "+
                  "style='font-size:10px'><u>Name reading(s):</u></span><br>");
          mainReadings=mainReadings.replace(/T2/,"<br><span "+
                  "style='font-size:10px'><u>Radical reading(s):</u></span><br>");
          var kdata=
              "<div style='font-size:12px;font-color:#3333FF;"+
              "background-color:#CCEEFF;border:1px outset #CCEEFF'>"+
              mainReadings+
              "</div>";
          var eigo=line.substring(end);
          eigo=replaceAll(eigo,"{","<li>");
          eigo=replaceAll(eigo,"}","");
          var moreinfo=line.substring(2,beg-1).split(" ");
          var infotxt="";
          var details="";
          {
              for (var i=0;i<moreinfo.length;i++) {
                  if (moreinfo[i]) {
                      var key=moreinfo[i].replace(/^([A-Z]+).*/,"$1");
                      var val=moreinfo[i].replace(/^([A-Z]+)(.*)/,"$2");
                      if (!moreinfo[key])
                          moreinfo[key]=val;
                      else 
                          moreinfo[key]+=" "+val;
                  }
              }
              var bushu="";
              if (moreinfo["B"]) {
                  bushu=radicalData[moreinfo["B"]]+" "+moreinfo["B"];
              }
              var grade="uncommon";
              if (moreinfo["G"]) {
                  grade=moreinfo["G"];
                  var numnames="one two three four five six seven".split(/ /);
                  if ((grade>0)&&(grade<8)) grade=numnames[grade-1];
                  if (grade=="8") grade="gen. use";
                  if (grade=="9") grade="names";
              }
              var freq="-";
              if (moreinfo["F"]) {
                  freq=moreinfo["F"];
              }
              var strokes="-";
              if (moreinfo["S"]) {
                  strokes=moreinfo["S"];
              }
              infotxt="<table border='1' cellpadding='1' cellspacing='0'><tr>"+
                  "<td style='font-size:10px' align='center' valign='top'><b>radical</b><br>"+
                  bushu+"</td>"+
                  "<td style='font-size:10px' align='center' valign='top'><b>grade</b><br>"+
                  grade+"</td>"+
                  "</tr><tr>"+
                  "<td style='font-size:10px' align='center' valign='top'><b>freq.</b><br>"+
                  freq+"</td>"+
                  "<td style='font-size:10px' align='center' valign='top'><b>strokes</b><br>"+
                  strokes+"</td>"+
                  "</tr></table>";
              var DetailControl=("C::Classical Radical::H::Halpern Index::N::Nelson "+
                  "Index::V::New Nelson Index::DR::Father Joseph De Roo Index::"+
                  "DK::Kanji Learners Dictionary Index::DO::P.G. O'Neill Index::"+
                  "P::Skip Pattern::U::Unicode Hex Value::I::Tuttle Kanji Dictionary::"+
                  "IN::Tuttle Kanji & Kana::Q::Four Corner Code::"+
                  "MN::Morohashi Daikanwajiten Index::"+
                  "MP::Morohashi Daikanwajiten Volume/Page::"+
                  "E::Henshall Index::K::Gakken Kanji Dictionary Index::"+
                  "L::Heisig Index::O::P.G. O'Neill Japanese Names Index::"+
                  "W::Korean Reading::Y::PinYin").split(/::/);
              var colors=("#FFFFFF::#DDDDDD").split(/::/);
              for (var i=0;i<DetailControl.length;i+=2) {
                  if (moreinfo[DetailControl[i]]) {
                      details+="<tr style='background-color:"+
                          colors[(i/2)%colors.length]+";'>"+
                          "<td style='font-size:10px'>"+
                          DetailControl[i+1]+"</td><td style='font-size:10px'>"+
                          moreinfo[DetailControl[i]]+"</td></tr>";
                  }
              }
              if (details!="") details="<table>"+details+"</table>";
          }
              
          return "<p align='center'><table width='90%'><tr>"+
              "<td align='center' valign='top'>"+
              "<span style='font-size:48px;font-family:serif;'>"+
              txt+
              "</span>"+
              "<div style='font-size:10px;text-align:left'>"+
              eigo+
              "</div></td>"+
              "<td valign='top' align='center'>"+
              rads+
              "<div style='padding:3px;'></div>"+
              infotxt+"</td>"+
              "</tr><tr>"+
              "<td colspan='2'>"+
              kdata+details+
              "</td>"+
              "</tr></table>";
      }
  }
  function kanjiLookupFormatEntry(i,inflect,reason) {
      var tstring=edictData[i].replace(
              /^([^ ]*) (\[([^\]]*)\] )?\/(.*)\//,"$1\n$3\n$4"
              ).split("\n");
      var ret="";
      txt=tstring[0];
      while ((i<edictData.length)&&(tstring[0]==txt)) {
          if ((!inflect)||(tstring[2].match(/[()]((adj)|(v[0-9a-t]))/))) {
              ret+="<span style=\"font-size:20px;"+
                  "color:#CC3333\">"+
                  tstring[0]+
                  "</span> "+
                  "<span style=\"color:#0000FF\">"+tstring[1]+
                  "</span>"+
                  (reason?("<span style=\"font-size:10px;\">("+
                           reason+")</span>"):"")+
                  "<br>"+
                  "<span style=\"font-size:12px\">- "+
                  (tstring[2]?replaceAll(tstring[2],"/","; "):"")+
                  "</span><br>";
          }
          i++;
          tstring=
              edictData[i].replace(
                      /^([^ ]*) (\[([^\]]*)\] )?\/(.*)\//,"$1\n$3\n$4"
                      ).split("\n");
      }
      return ret;
  }
  /* try to conjugate txt into other possibilities, return array 
     of object(txt,reason). no reason for txt, which is returned */
  function kanjiConjugate(txt) {
      var ret=new Array();
      ret.push(new Object());
      ret[0].txt=txt;
      var wordHash=new Object();
      wordHash[txt]=true;
      var debug="";
      for (var i=0;i<vconjData.length;i++) {
          var vconjDataElement=vconjData[i];
          if (!vconjDataElement.before) continue;
          var olen=ret.length;
          for (var w=0;w<olen;w++) {
              var ind=ret[w].txt.lastIndexOf(vconjDataElement.before);
              if (ind!=-1) {
                  if (ind==ret[w].txt.length-vconjDataElement.before.length) {
                      var o=new Object();
                      o.txt=ret[w].txt.substr(0,ind)+
                          vconjDataElement.after;
                      if (!wordHash[o.txt]) {
                          if (ret[w].reason) {
                              o.reason=ret[w].reason+", "+vconjDescription[vconjDataElement.reason];
                          } else {
                              o.reason=vconjDescription[vconjDataElement.reason];
                          }
                          ret.push(o);
                      }
                  }
              }
          }
      }
      return ret;
  }
  function kanjiLookup(txt) {
      var ret="";
      var gotcha=new Object();
      while (txt.length>0) {
          var trys=kanjiConjugate(txt);
          for (var i=0;i<trys.length;i++) {
              var index=binSearch(edictData,trys[i].txt,0,edictData.length-1);
              var edictEntry =edictData[index].replace(
                      /^([^ ]*) (\[([^\]]*)\] )?\/(.*)\//,"$1\n$3\n$4"
                      ).split("\n");
              if ((edictEntry[0]==trys[i].txt)&&(!gotcha[index])) {
                  ret+=kanjiLookupFormatEntry(index,i>0,trys[i].reason);
                  gotcha[index]=true;
              }
          }
          txt=txt.replace(/.$/,"");
      }
      return ret;
  }

